; $Id: pan_readktable.pro,v 1.2 2002/01/14 20:59:25 amunter Exp $
; pan_readktable.pro
;
;
; Reads in a set of tabulated data of the kohlrausch stretched
; exponential function (actually the Fourier transform of it)
; where the three dimensional grid is energy, beta, and tau.
;
; The table, called kohlrauschtable.txt is generated with
; createKTableFile.pro and John Nolan's program STABLE.EXE.
;
; Written by R.M.Dimeo (6/5/01)
;
;;;;;;;;;;;;;;;;;;;;
pro pan_readKTable,kPtr
if file_which('kohlrauschtable.txt') eq '' then begin
  file = 'kohlrauschtable.txt'
endif else begin
  file = file_which('kohlrauschtable.txt')
endelse
openr, lun, file, /get_lun
   readf,lun,npts,nb,nt
   yout = dblarr(npts+1,nb+1,nt+1)
   readf, lun, yout
free_lun, lun
kPtr = ptr_new(yout)

return
end
;;;;;;;;;;;;;;;;;;